package com.yihu.quota.controller;

import com.yihu.ehr.constants.ApiVersion;
import com.yihu.ehr.util.rest.Envelop;
import com.yihu.quota.model.cube.Cube;
import com.yihu.quota.model.view.View;
import com.yihu.quota.model.view.ViewQuota;
import com.yihu.quota.service.cube.CubeService;
import com.yihu.quota.service.view.ViewQuotaService;
import com.yihu.quota.service.view.ViewService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author janseny
 * @date 2018年9月26日
 */
@RestController
@RequestMapping(ApiVersion.Version1_0 + "/viewQuota")
@Api(description = "OLAP 视图指标 控制入口")
public class ViewQuotaController extends BaseController {

    @Autowired
    private ViewQuotaService viewQuotaService;
    @Autowired
    private ViewService viewService;

    @ApiOperation(value = "添加视图指标")
    @RequestMapping(value = "/addViewQuota", method = RequestMethod.GET)
    public Envelop addViewQuota(
            @ApiParam(name = "code", value = "维度code", required = true)
            @RequestParam(value = "code", required = true) String code,
            @ApiParam(name = "name", value = "维度名称", required = true)
            @RequestParam(value = "name", required = true) String name,
            @ApiParam(name = "viewId", value = "多维数据集ID", required = true)
            @RequestParam(value = "viewId", required = true) int viewId,
            @ApiParam(name = "formulaMode", value = "计算方式，1：基础公式，2：自定义公式。", required = true)
            @RequestParam(value = "formulaMode", required = false) String formulaMode,
            @ApiParam(name = "basicFormulaType", value = "基础公式：1：求和，2.计数，3：均值，4：最大值，5：最小值，6：去重计数", required = false)
            @RequestParam(value = "basicFormulaType", required = false) String basicFormulaType,
            @ApiParam(name = "chartType", value = "图表类型，1：折线图，2：柱状图。", required = false)
            @RequestParam(value = "chartType", required = false) String chartType
    ){
        Envelop envelop = new Envelop();
        envelop.setSuccessFlg(true);
        try {
            View view = viewService.findOne(viewId);
            ViewQuota viewQuota = new ViewQuota();
            viewQuota.setViewId(viewId);
            viewQuota.setDimensionCode(code);
            viewQuota.setDimensionName(name);
            String dataset = view.getDimensionDataset();
            viewQuota.setEsIndex(dataset.substring(0, dataset.indexOf("/")));
            viewQuota.setEsIndex(dataset.substring(dataset.indexOf("/") + 1));
            viewQuota.setFormulaMode(formulaMode);
            viewQuota.setBasicFormulaType(basicFormulaType);
            viewQuota.setChartType(chartType);
            viewQuotaService.save(viewQuota);
        }catch (Exception e){
            e.printStackTrace();
            envelop.setSuccessFlg(false);
        }
        return envelop;
    }

    @ApiOperation(value = "删除视图指标")
    @RequestMapping(value = "/delViewQuota", method = RequestMethod.DELETE)
    public Envelop delViewQuota(
            @ApiParam(name = "id", value = "ID", required = true)
            @RequestParam(value = "id", required = true) int id){
        Envelop envelop = new Envelop();
        envelop.setSuccessFlg(true);
        viewQuotaService.delete(id);
        return envelop;
    }


}
