package com.yihu.quota.model.view;


import com.yihu.ehr.entity.BaseAssignedEntity;
import com.yihu.ehr.entity.BaseIdentityEntity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.List;

/**
 * 视图 entity
 *
 * @author janseny
 * @date 2018年9月26日
 */
@Entity
@Table(name = "olap_view")
public class View extends BaseAssignedEntity {

    private String code; // 视图编码
    private String name; // 视图名称
    private String esIndex; // 多维数据集的 ES index，多个的话用逗号分隔
    private String esType; // 多维数据集的 ES type，多个的话用逗号分隔
    private String displayType; //  展示类型，1：数值，2：普通表格，3：树形表格，4：饼图，5：折线图，6：柱状图，7：组合图（折线图+柱状图），8：雷达图，9：旭日图。
    private String treeDataType; // 树形数据类型，org_type_tree：机构类型树形数据。
    private String isDrill; // 可钻取，1：可以，2：不可以。
    private String remark; // 备注

    // 临时属性
    /**
     * 视图默认过滤条件
     */
    private List<ViewQuotaFilter> viewFilterList;
    /**
     * 视图维度
     */
    private List<ViewDimension> viewDimensionList;
    /**
     * 视图指标
     */
    private List<ViewQuota> viewQuotaList;

    @Column(name = "code")
    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    @Column(name = "name")
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Column(name = "es_index")
    public String getEsIndex() {
        return esIndex;
    }

    public void setEsIndex(String esIndex) {
        this.esIndex = esIndex;
    }

    @Column(name = "es_type")
    public String getEsType() {
        return esType;
    }

    public void setEsType(String esType) {
        this.esType = esType;
    }

    @Column(name = "display_type")
    public String getDisplayType() {
        return displayType;
    }

    public void setDisplayType(String displayType) {
        this.displayType = displayType;
    }

    @Column(name = "tree_data_type")
    public String getTreeDataType() {
        return treeDataType;
    }

    public void setTreeDataType(String treeDataType) {
        this.treeDataType = treeDataType;
    }

    @Column(name = "is_drill")
    public String getIsDrill() {
        return isDrill;
    }

    public void setIsDrill(String isDrill) {
        this.isDrill = isDrill;
    }

    @Column(name = "remark")
    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    @Transient
    public List<ViewQuotaFilter> getViewFilterList() {
        return viewFilterList;
    }

    public void setViewFilterList(List<ViewQuotaFilter> viewFilterList) {
        this.viewFilterList = viewFilterList;
    }

    @Transient
    public List<ViewDimension> getViewDimensionList() {
        return viewDimensionList;
    }

    @Transient
    public void setViewDimensionList(List<ViewDimension> viewDimensionList) {
        this.viewDimensionList = viewDimensionList;
    }

    public List<ViewQuota> getViewQuotaList() {
        return viewQuotaList;
    }

    public void setViewQuotaList(List<ViewQuota> viewQuotaList) {
        this.viewQuotaList = viewQuotaList;
    }
}
