package com.yihu.quota.model.view;


import com.yihu.ehr.entity.BaseAssignedEntity;
import com.yihu.ehr.entity.BaseIdentityEntity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.List;

/**
 * 视图指标 entity
 *
 * @author janseny
 * @date 2018年9月26日
 */
@Entity
@Table(name = "olap_view_quota")
public class ViewQuota extends BaseAssignedEntity {

    public Integer viewId; // 视图Id
    public String dimensionCode; // 维度编码
    public String dimensionName; // 维度名称
    public String esIndex; // 多维数据集的 ES index
    public String esType; //  多维数据集的 ES type
    public String formulaMode; // 计算方式，basic：基础公式，custom：自定义公式。
    public String basicFormulaType; // 基础公式：sum：求和，count.计数，avg：均值，max：最大值，min：最小值，cardinality：去重计数
    public String chartType; // 图表类型，line：折线图，bar：柱状图。

    // 临时属性
    /**
     * 指标过滤条件
     */
    public List<ViewQuotaFilter> quotaFilterList;

    @Column(name = "view_id")
    public Integer getViewId() {
        return viewId;
    }

    public void setViewId(Integer viewId) {
        this.viewId = viewId;
    }

    @Column(name = "dimension_code")
    public String getDimensionCode() {
        return dimensionCode;
    }

    public void setDimensionCode(String dimensionCode) {
        this.dimensionCode = dimensionCode;
    }

    @Column(name = "dimension_name")
    public String getDimensionName() {
        return dimensionName;
    }

    public void setDimensionName(String dimensionName) {
        this.dimensionName = dimensionName;
    }

    @Column(name = "es_index")
    public String getEsIndex() {
        return esIndex;
    }

    public void setEsIndex(String esIndex) {
        this.esIndex = esIndex;
    }

    @Column(name = "es_type")
    public String getEsType() {
        return esType;
    }

    public void setEsType(String esType) {
        this.esType = esType;
    }

    @Column(name = "formula_mode")
    public String getFormulaMode() {
        return formulaMode;
    }

    public void setFormulaMode(String formulaMode) {
        this.formulaMode = formulaMode;
    }

    @Column(name = "basic_formula_type")
    public String getBasicFormulaType() {
        return basicFormulaType;
    }

    public void setBasicFormulaType(String basicFormulaType) {
        this.basicFormulaType = basicFormulaType;
    }

    @Column(name = "chart_type")
    public String getChartType() {
        return chartType;
    }

    public void setChartType(String chartType) {
        this.chartType = chartType;
    }

    @Transient
    public List<ViewQuotaFilter> getQuotaFilterList() {
        return quotaFilterList;
    }

    public void setQuotaFilterList(List<ViewQuotaFilter> quotaFilterList) {
        this.quotaFilterList = quotaFilterList;
    }
}
